:root {
    .theme-base {
        --prim-highlight: rgba(var(--prim-rgb), 0.3);

        --default-color: #636363;
        --success-color: #28a745;
        --info-color: #17a2b8;
        --warning-color: #ffc107;
        --danger-color: #dc3545;
    }

    .theme-dark {
        --base-color: rgb(0, 0, 0);
        --base-color-rgb: 0, 0, 0;
        --base-light: rgba(var(--base-color-rgb), 0.05);
        --base-lighter: rgba(var(--base-color-rgb), 0.1);
        --base-highlight: rgba(var(--base-color-rgb), 0.15);

        --contrast-color: rgb(255, 255, 255);
        --contrast-color-rgb: 255, 255, 255;
        --contrast-light: rgba(var(--contrast-color-rgb), 0.05);
        --contrast-lighter: rgba(var(--contrast-color-rgb), 0.1);
        --contrast-highlight: rgba(var(--contrast-color-rgb), 0.15);

        --background-color: hsl(0, 0%, 19%);
        --bg-dark: hsl(0, 0%, 13%);
        --bg-light: hsl(0, 0%, 37%);

        // control
        --sidebar-bg: var(--background-color);
        --tab-bg: hsl(0, 0%, 31%);

        --panel-footer-bg: hsl(0, 0%, 26%);
        --panel-header-bg: hsl(0, 0%, 13%);
        --panel-bg: hsl(0, 0%, 19%);
        --panel-split: inset 2px 0 2px 0 rgba(110, 110, 110, 0.4), -2px 0px 2px 0px rgb(24, 24, 24);

        --button-color: var(--contrast-color);
        --form-control-bg: rgba(var(--base-color-rgb), 0.2);

        --popup-border: hsl(0, 0%, 48%);
        --popup-bg: hsl(0, 0%, 23%);
        --popup-border-radius: 0.5rem;

        --marker-popup-border-radius: 0.25rem;

        --border: var(--contrast-highlight);
        --border-light: rgb(172, 172, 172);
        --border-rgb: 219, 221, 225;

        // text
        --text-color: rgba(var(--contrast-color-rgb), 0.8);
        --text-color-rgb: var(--contrast-color-rgb);
        --text-color-light: rgba(var(--contrast-color-rgb), 0.9);
        --text-color-dark: rgba(var(--contrast-color-rgb), 0.6);

        //.app-overlay,
        .action-menu,
        .mapboxgl-popup,
        .map-control-button,
            //.mapboxgl-popup,
            //.tooltip,
            //.mapboxgl-marker,
        {
            --base-color: rgb(255, 255, 255);
            --base-color-rgb: 255, 255, 255;
            --base-light: rgba(var(--base-color-rgb), 0.05);
            --base-lighter: rgba(var(--base-color-rgb), 0.1);
            --base-highlight: rgba(var(--base-color-rgb), 0.15);

            --contrast-color: rgb(0, 0, 0);
            --contrast-color-rgb: 0, 0, 0;
            --contrast-light: rgba(var(--contrast-color-rgb), 0.05);
            --contrast-lighter: rgba(var(--contrast-color-rgb), 0.1);
            --contrast-highlight: rgba(var(--contrast-color-rgb), 0.15);

            --background-color: hsl(200, 37%, 97%);
            --bg-dark: hsl(200, 37%, 94%);
            --bg-light: hsl(200, 37%, 98%);

            // control
            --button-color: var(--base-color);
            --form-control-bg: var(--base-color);

            --panel-header-bg: var(--base-color);
            --panel-footer-bg: var(--base-color);
            --panel-split: none;

            --popup-border: hsl(0, 0%, 48%);
            --popup-bg: rgb(244, 248, 250);
            --popup-border-radius: 0.5rem;

            --marker-popup-border-radius: 0.625rem;

            --border: var(--contrast-highlight);
            --border-light: rgb(172, 172, 172);
            --border-rgb: 219, 221, 225;

            // text
            --text-color: rgba(var(--contrast-color-rgb), 0.6);
            --text-color-rgb: var(--contrast-color-rgb);
            --text-color-light: rgba(var(--contrast-color-rgb), 0.8);
            --text-color-dark: rgb(119, 119, 119);

            --default-color: var(--text-color);
        }
    }

    .theme-light {
        --base-color: rgb(255, 255, 255);
        --base-color-rgb: 255, 255, 255;
        --base-light: rgba(var(--base-color-rgb), 0.05);
        --base-lighter: rgba(var(--base-color-rgb), 0.1);
        --base-highlight: rgba(var(--base-color-rgb), 0.15);

        --contrast-color: rgb(0, 0, 0);
        --contrast-color-rgb: 0, 0, 0;
        --contrast-light: rgba(var(--contrast-color-rgb), 0.05);
        --contrast-lighter: rgba(var(--contrast-color-rgb), 0.1);
        --contrast-highlight: rgba(var(--contrast-color-rgb), 0.15);

        --background-color: hsl(0, 0%, 100%);
        --bg-dark: hsl(0, 0%, 90%);
        --bg-light: hsl(210, 43%, 100%);

        // control
        --sidebar-bg: hsl(210, 43%, 97%);
        --tab-bg: hsl(0, 0%, 90%);

        --panel-footer-bg: hsl(0, 0%, 90%);
        --panel-header-bg: hsl(0, 0%, 98%);
        --panel-bg: hsl(0, 0%, 100%);
        --panel-split: inset 1px 0 1px 0 rgba(110, 110, 110, 0.4);

        --button-color: var(--base-color);
        --form-control-bg: rgba(var(--base-color-rgb), 0.2);

        --popup-border: hsl(0, 0%, 48%);
        --popup-bg: hsl(0, 0%, 100%);
        --popup-border-radius: 0.5rem;

        --marker-popup-border-radius: 0.25rem;

        --border: var(--contrast-highlight);
        --border-light: rgb(172, 172, 172);
        --border-rgb: 219, 221, 225;

        // text
        --text-color: rgba(var(--contrast-color-rgb), 0.8);
        --text-color-rgb: var(--contrast-color-rgb);
        --text-color-light: rgba(var(--contrast-color-rgb), 0.9);
        --text-color-dark: rgba(var(--contrast-color-rgb), 0.6);
    }

    // please don't use, just for color reference
    --indigo: #6610f2;
    --purple: #6f42c1;
    --pink: #e83e8c;
    --red: #dc3545;
    --orange: #fd7e14;
    --yellow: #ffc107;
    --green: #28a745;
    --teal: #20c997;
    --cyan: #17a2b8;

    // not using yet
    --breakpoint-xs: 0;
    --breakpoint-sm: 576px;
    --breakpoint-md: 768px;
    --breakpoint-lg: 992px;
    --breakpoint-xl: 1200px;

    --font-family-sans-serif: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, "Noto Sans", sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol", "Noto Color Emoji";
    --font-family-monospace: SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace;
}

html {
    @media (min-width: 768px) {
        font-size: 12.5px;
    }

    @media (min-width: 1200px) {
        font-size: 13.6px;
    }

    @media (min-width: 1800px) {
        font-size: 14px;
    }

    @media (min-width: 2400px) {
        font-size: 16px;
    }
}

body, button, h1, h2, h3, h4, h5, h6, ol, p, input, textarea, th, ul, div, span, i, pre {
    font-size: 0.875rem;
}

.no-data {
    font-style: italic;
    opacity: 0.2;
}
